Codeforces-Round-#363-Fix-a-Tree

来源:互联网 发布:开源软件许可证类型 编辑:程序博客网 时间:2024/06/06 15:52
Fix a Tree
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

A tree is an undirected connected graph without cycles.

Let's consider a rooted undirected tree with n vertices, numbered 1 through n. There are many ways to represent such a tree. One way is to create an array with n integers p1, p2, ..., pn, where pi denotes a parent of vertex i (here, for convenience a root is considered its own parent).

For this rooted tree the array p is [2, 3, 3, 2].

Given a sequence p1, p2, ..., pn, one is able to restore a tree:

  1. There must be exactly one index r that pr = r. A vertex r is a root of the tree.
  2. For all other n - 1 vertices i, there is an edge between vertex i and vertex pi.

A sequence p1, p2, ..., pn is called valid if the described procedure generates some (any) rooted tree. For example, for n = 3sequences (1,2,2)(2,3,1) and (2,1,3) are not valid.

You are given a sequence a1, a2, ..., an, not necessarily valid. Your task is to change the minimum number of elements, in order to get a valid sequence. Print the minimum number of changes and an example of a valid sequence after that number of changes. If there are many valid sequences achievable in the minimum number of changes, print any of them.

Input

The first line of the input contains an integer n (2 ≤ n ≤ 200 000) — the number of vertices in the tree.

The second line contains n integers a1, a2, ..., an (1 ≤ ai ≤ n).

Output

In the first line print the minimum number of elements to change, in order to get a valid sequence.

In the second line, print any valid sequence possible to get from (a1, a2, ..., an) in the minimum number of changes. If there are many such sequences, any of them will be accepted.

Examples
input
42 3 3 4
output
12 3 4 4 
input
53 2 2 5 3
output
03 2 2 5 3 
input
82 3 5 4 1 6 6 7
output
22 3 7 8 1 6 6 7
Note

In the first sample, it's enough to change one element. In the provided output, a sequence represents a tree rooted in a vertex 4(because p4 = 4), which you can see on the left drawing below. One of other correct solutions would be a sequence 2 3 3 2, representing a tree rooted in vertex 3 (right drawing below). On both drawings, roots are painted red.

In the second sample, the given sequence is already valid.


题意:按顺序给出n个节点的父节点编号,要求用最少的操作次数,把这个图变成树。

题目链接:Fix a Tree

解题思路:
清楚树的两个要求,1.不存在环,2.只有一个根。
因此可以用并查集把最优树的根确定下来,要操作修改的地方就是有 环  和 多个根 的情况,对于环的情况,也可以用并查集处理,直接把这个节点接到根上(答案不唯一)。
多个根情况也如此,也把这个节点接到根上。
用cnt 记录上述情况出现的次数,表示要操作的次数。


代码:

0 0
原创粉丝点击